%-----------------------------------------------------------------------------
%
%  Realtime Programming with Preempt-RT
%
%  vim: spelllang=en spell
%
%-----------------------------------------------------------------------------

\documentclass{beamer}
%\documentclass[handout]{beamer}

\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{times}
\usepackage{graphicx}
\usepackage[overlay,absolute]{textpos}
\usepackage{listings}

\hypersetup{colorlinks,urlcolor=blue,linkcolor=black}

\input{git}

\setlength{\TPHorizModule}{1mm}
\setlength{\TPVertModule}{1mm}

\lstset{
    basicstyle=\ttfamily\scriptsize,
    numberstyle=\tiny,
    numbers=left,
    xleftmargin=5mm,
    breaklines=true,
    commentstyle=\color{blue},
    stringstyle=\color{red}
}

%-----------------------------------------------------------------------------

\usetheme{IgH}

\setbeamertemplate{IgH footer}{
    Rev.~\revision, \today
    \hfil
    Ingenieurgemeinschaft IgH -- \url{https://igh.de}
    \hfil
    \insertpagenumber\ / \insertdocumentendpage
}

\title{Realtime Application Development}
\subtitle{using Linux and PREEMPT\_RT}
\author[IgH]{Ingenieurgemeinschaft IgH}
\date{\today}

\logo{\includegraphics[width=.17\textwidth]{images/igh+logo}}

\AtBeginSection[]
{
    \begin{frame}<beamer>
        \frametitle{Inhalt}
        \tableofcontents[currentsection]
    \end{frame}
}

%-----------------------------------------------------------------------------

\begin{document}

\begin{frame}

    \titlepage

    \begin{textblock}{30}(5,55)
        \includegraphics[width=\textwidth]{images/process}
    \end{textblock}

\end{frame}

%-----------------------------------------------------------------------------

\section{System Preparation}

\begin{frame}
    \frametitle{Get a Realtime Kernel}

    \begin{textblock}{30}(70,60)
        \includegraphics[width=\textwidth]{images/process}
    \end{textblock}

    \begin{itemize}

        \item Most distribution supply a respective kernel package
            (\lstinline+kernel-rt+)

        \item If a special kernel version is needed, or the distributor does
            not supply one at all, you have to build it yourself

        \item See the
            \href{https://wiki.linuxfoundation.org/realtime/documentation/howto/applications/preemptrt_setup}{PREEMPT\_RT
            Setup} on wiki.linuxfoundation.org for that
    \end{itemize}

\end{frame}

\begin{frame}[fragile]
    \frametitle{Building a Linux Realtime Kernel}

    \begin{lstlisting}[language=bash]
wget https://www.kernel.org/pub/linux/kernel/v4.x/linux-4.4.302.tar.xz
wget https://www.kernel.org/pub/linux/kernel/projects/rt/4.4/patch-4.4.302-rt232.patch.xz
    \end{lstlisting}

    \begin{lstlisting}
xz -cd linux-4.4.302.tar.xz | tar xf -
cd linux-4.4.302
xzcat ../patch-4.4.302-rt232.patch.xz | patch -p1
cd ..
mv linux-4.4.302 linux-4.4.302-rt232
mkdir linux-4.4.302-rt232-build
cd linux-4.4.302-rt232-build
make -C ../linux-4.4.302-rt232 O=$(pwd -P) oldconfig
make menuconfig
    \end{lstlisting}

    In \textit{Processor type and features} $\rightarrow$ \textit{Preemption
    Model} select \textit{Fully Preemptible Kernel (RT)}

    \begin{lstlisting}[firstnumber=last]
make && sudo make modules_install install
    \end{lstlisting}

\end{frame}

%-----------------------------------------------------------------------------

\section{Basic Realtime Application}

\begin{frame}
    \frametitle{Building a basic Realtime Application}

    See
    \href{https://wiki.linuxfoundation.org/realtime/documentation/howto/applications/application_base}{HOWTO
    build a simple RT application} on linuxfoundation.org

    \begin{exampleblock}{It's about}
        \begin{itemize}
            \item Scheduling and priority
            \item Memory locking
            \item Reserving stack memory
        \end{itemize}
    \end{exampleblock}

    \pause

    $\Rightarrow$ Example Code \texttt{0-basic-realtime-thread.c}
\end{frame}

\begin{frame}
    \frametitle{Creating a Cyclic Application}

    See
    \href{https://wiki.linuxfoundation.org/realtime/documentation/howto/applications/cyclic}
    {HOWTO build a basic cyclic application} on
    linuxfoundation.org

    \begin{exampleblock}{It's about}
        \begin{itemize}
            \item Defining your cycle time / period
            \item Starting a loop with your cyclic calculations
            \item Using \lstinline+clock_nanosleep()+ and \lstinline+CLOCK_MONOTONIC+
                to waiting for the \textbf{rest} of the period
        \end{itemize}
    \end{exampleblock}

    \pause

    $\Rightarrow$ Example Code \texttt{1-cyclic-realtime-process.c}
\end{frame}

%-----------------------------------------------------------------------------

\section{Basic EtherCAT Application}

\begin{frame}
    \frametitle{Including EtherCAT}

    \begin{exampleblock}{It's about}
        \begin{itemize}
            \item Requesting a master
            \item Creating domains
            \item Creating slave configurations
            \item Defining the PDO mapping
            \item Registering PDOs for cyclic exchange
            \item Activating the Master
            \item Sending / receiving frames and accessing process data
        \end{itemize}
    \end{exampleblock}

    \begin{textblock}{30}(65,30)
        \includegraphics[width=\textwidth]{images/ethercat}
    \end{textblock}

    \pause

    $\Rightarrow$ Example Code \texttt{2-ethercat-process.c}
\end{frame}

%-----------------------------------------------------------------------------

\section{Including PdServ}

\begin{frame}
    \frametitle{Including PdServ}

    \begin{exampleblock}{It's about}
        \begin{itemize}
            \item Creating a PdServ instance
            \item Creating tasks
            \item Registering signals and parameters
            \item Preparing PdServ
            \item Updating tasks in cyclic operation
        \end{itemize}
    \end{exampleblock}

    \begin{textblock}{33}(63,38)
        \includegraphics[width=\textwidth]{images/pdserv}
    \end{textblock}

    \pause

    $\Rightarrow$ Example Code \texttt{3-ethercat-pdserv.c}
\end{frame}

%-----------------------------------------------------------------------------

\end{document}

%-----------------------------------------------------------------------------
